using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;
using Decal.Interop.Core;

namespace Decal.Interop.Inject;

[ComImport]
[Guid("BE566CEC-6881-481C-A146-9F5A32576BE6")]
[TypeLibType(4096)]
[SuppressUnmanagedCodeSecurity]
public interface IImageCache
{
	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	void PatBlt([MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagRECT prcDest, ref tagPOINT ptOrigin);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	void StretchBlt([MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagPOINT pptDest, int nWidth, int nStartStretch, int nEndStretch);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	void Blt(ref tagRECT rcSrc, [MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagPOINT pptDest);

	[DispId(1610743811)]
	tagSIZE Size
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		get;
	}

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	void StretchBltArea(ref tagRECT prcSrc, [MarshalAs(UnmanagedType.Interface)] Canvas pDest, ref tagRECT prcDest);
}
